<template>
  <Page>
    <StackLayout>
      <Button text="Start Game" @tap="startGame"/>
      <Label :text="'Score : ' + score"/>

      <AbsoluteLayout v-if="avatar">
        <Image :src="avatar" width="100" height="200" :top="position.y" :left="position.x"/>

        <Image
          src="~/assets/images/img1.jpg"
          width="100"
          height="75"
          v-for="(obstacle, index) in obstacles"
          :key="index"
          :top="obstacle.y"
          :left="obstacle.x"
        />
      </AbsoluteLayout>
    </StackLayout>
  </Page>
</template>

<script>
import * as camera from "nativescript-camera";
import * as accel from "nativescript-accelerometer";
import * as platformModule from "tns-core-modules/platform";

export default {
  data() {
    return {
      avatar: "",
      position: {
        x: 100,
        y: 100
      },
      obstacles: [],
      score: 0
    };
  },
  methods: {
    startGame() {
      camera
        .takePicture({ saveToGallery: false, cameraFacing: "front" })
        .then(image => {
          this.avatar = image;

          setInterval(this.createObstacle, 1000);

          accel.startAccelerometerUpdates(
            data => {
              this.position.x += data.x * 2;
              this.position.y -= data.y * 2;
              this.score += 1;
              this.obstacles.forEach((obstacle, index) => {
                obstacle.y += 1;
                if (obstacle.y > platformModule.screen.mainScreen.heightDIPs) {
                  this.obstacles.splice(index, 1);
                }
                if(this.isColliding(obstacle)) {
                    this.score -= 1000;
                    this.obstacles.splice(index, 1);
                }
              });
            },
            { sensorDelay: "fastest" }
          );
        })
        .catch(err => console.error(err));
    },
    createObstacle() {
      this.obstacles.push({
        y: -100,
        x: Math.random() * 500
      });
    },
    isColliding(obstacle) {
      return (
        obstacle.x < this.position.x + 100 &&
        obstacle.x + 100 > this.position.x &&
        obstacle.y < this.position.y + 200 &&
        75 + obstacle.y > this.position.y
      );
    }
  },
  destroyed() {
    accel.stopAccelerometerUpdates();
  }
};
</script>

<style scoped>
label {
  font-size: 40;
}
</style>
